* creation 29.6.99
	opt h+

_ILOSCBANKOW EQU 9
_ROMRAM EQU $FE

SINGS EQU $b000

JEST_TEST EQU 1  ;0=brak

*ZP EQU 0

zNIC EQU $80
zADR EQU $90

IO   EQU $340

PORTB EQU $D301
NMIEN EQU $D40E


     org sings
     ins 'tilt.fnt'


     ORG $9200

* jest rozszerzenie?

START LDA #$EF
      STA PORTB
      STA $7FFF
      
 LDA #$FF
 STA PORTB
 STA $7FFF

 LDA #$EF
 STA PORTB

 LDA $7FFF
 CMP #$FF
 BNE j9

 LDX <tNOextraRAM
 LDY >tNOextraRAM
 JSR $C642
 JMP EXIT

tNOextraRAM DTA C'Brak rozszerzenia pamieci !',B(155)

j9 EQU *

* safe data in bank

   LDX #0
_s1 LDA dBANK,X
   STA PORTB

 LDA $7FFF
 STA dSAFE,X
 LDA #$FF
 STA $7FFF

 INX
 CPX #32
 BCC _s1

* test number bank

* zapisuje nr do banku E3 i spraw.
* w C3 czy jest ten sam nr
* jesli tak = dublowany bank
* nie = inny bank, itd z C3 i A3 w dol

     LDX #0

nLOP LDA #$FF        ;Y>$80 dublowany
n1   STA dJESTbank,X ;Y=$FF inny bank

 LDA dBANK,X
 STA PORTB

 STX $7FFF

 INX
 CPX #32
 BEQ nKONEC

 TXA
 AND #7
 BEQ nLOP ;banki E3 E7 EB EF sa obecne

 LDA dBANK,X
 STA PORTB

 LDA #$7F
 CMP $7FFF
 BCC nLOP  ;zgodny numer = dubel
 BCS n1

nKONEC EQU *



* reanimation data

   LDX #31
_r3 LDA dBANK,X
   STA PORTB

 LDA dSAFE,X
 STA $7FFF

 DEX
 BPL _r3


* wybierz pierwszych 16



 LDX #0
 LDY #0

w3 LDA dJESTbank,X
   BPL w9

 LDA dBANK,X
 STA dBANK16,Y
 INY
 CPY #_ILOSCBANKOW
 BEQ mamBANKI

w9 INX
   CPX #32
   BCC w3

 LDX <tNObank
 LDY >tNObank
 JSR $C642
 LDA $2F2
*CMP #''
 cmp #$e7
 BEQ mamBANKI ;skip to test
 JMP EXIT

tNObank DTA C'Potrzebuje 192KB dodatkowej pamieci !',B(155)

mamBANKI EQU *

 LDA #$FF
 STA PORTB
 sta $2f2
 JSR SETUP
 BCC s_

 JMP EXIT

* wybierz pierwszych 16 w/g uzytkow.


s_ LDY #0
   STY zNIC+2

_w1 LDX #0
_w3 JSR seADR

  LDY #0
  LDA (zNIC),Y
*CMP #' '+64
  cmp #$40
  BNE _w9

 LDY zNIC+2
 LDA dBANK,X
 STA dBANK16,Y
 INY
 STY zNIC+2
 CPY #_ILOSCBANKOW
 BEQ _mamBANKI

_w9 INX
    CPX #32
    BCC _w3
    BCS _w1

_mamBANKI EQU *

* ------------------
* move & run


EXIT LDA #$FF
     STA PORTB
     sta 764
     
exi  ldy 764
     iny
     beq exi
;    lda #0
;    sta 559
     lda #$ff
     sta 764
     pla
     pla
     rts
     
*     JSR $F2F8
*     JMP INITcd

dBANK EQU *

 DTA B($E3),B($C3),B($A3),B($83),B($63),B($43),B($23),B($03)
 DTA B($E7),B($C7),B($A7),B($87),B($67),B($47),B($27),B($07)
 DTA B($EB),B($CB),B($AB),B($8B),B($6B),B($4B),B($2B),B($0B)
 DTA B($EF),B($CF),B($AF),B($8F),B($6F),B($4F),B($2F),B($0F)

dJESTbank DTA C'                                  '
dSAFE     DTA C'                                  '
* dBANK16   DTA C'                  '

* -------------

SETUP EQU *

* wpis do ekranu

 LDA #3
 LDX #0
 STA zNIC+5
 STX zNIC+2

seLOP JSR seADR

*LDA #''+64
 lda #$42
 LDY dJESTbank,X
 BPL se5
*LDA #''+64
 lda #$41
 LDY zNIC+2
 CPY #_ILOSCBANKOW
 BCS *+6
*LDA #' '+64
 lda #$40
 INC zNIC+2

se5 LDY #0
 STA (zNIC),Y

 INX
 CPX #32
 BCC seLOP

 LDA <DL
 LDX >DL
 STA 560
 STX 561
 LDA >SINGS
 STA 756

 lda 20
 cmp 20
 beq *-2 
 jsr sprite

WYB_START LDX #0
WYB_LOCK  STX zNIC+3

WYBOR JSR MIG
      LDA 20

 CLC
 ADC #5
sA CMP 20
   BNE sA
 JSR MIG

   LDA 20
 CLC
 ADC #25
 LDY #$FF
sB CPY $2F2
   BNE sC
   CMP 20
   BNE sB
   BEQ WYBOR

sC LDA $2F2
   STY $2F2

 AND #31
*CMP #''
 cmp #$e
 BEQ UP
*CMP #''
 cmp #$f
 BEQ DOWN

 CMP #12
 BNE WYBOR

 CPX #1
 BCC DONE_EXIT
 BEQ out

 CPX #2
 BEQ EDIT

DONE_EXIT equ *		;wyjscie i ladowanie dalszej czesci
 jsr clear
 pla
 pla
 RTS
 
out jsr clear
 pla
 pla
 jmp ($a)

clear lda #0
 sta 559
 sta $d01d
 sta 623
 sta $d000
 sta $d001
 sta $d002
 sta $d003
 sta $d004
 jsr ClrPM
 rts

UP DEX
   BPL WYB_LOCK
 LDX #2
 BNE WYB_LOCK

DOWN INX
     CPX #3
     BCC WYB_LOCK
     BCS WYB_START

EDIT STX zNIC+3

     LDX #0
     STX zNIC+4

EDIT_LOP JSR seADR

 LDY #0
 LDA (zNIC),Y
 PHA
 EOR #128
 STA (zNIC),Y

 BIT fSING
 BPL e9

   LDY #8
e8 LDA SINGS+688-1,Y
   STA SINGS+520-1,Y
 DEY
 BNE e8

e9 LDA 20
 CLC
 ADC #5
eA CMP 20
   BNE eA

 PLA
 STA (zNIC),Y

   LDY #8
e_ LDA SINGS+696-1,Y
   STA SINGS+520-1,Y
 DEY
 BNE e_


 LDA 20
 CLC
 ADC #25
 LDY #$FF
eB CPY $2F2
   BNE eC
   CMP 20
   BNE eB
   BEQ EDIT_LOP

eC LDA $2F2
   STY $2F2

 AND #31
*CMP #''
 cmp #$e
 BEQ UP1
*CMP #''
 cmp #$f
 BEQ DOWN1
*CMP #''
 cmp #6
 BEQ LEFT
*CMP #''
 cmp #7
 BEQ RIGHT
 CMP #12
 BEQ RETURN

*CMP #''
 cmp #$1c
 BNE EDIT_LOP

 LDA #JEST_TEST
 BNE eX

 BIT fSING
 BMI EDIT_LOP

eX LDX zNIC+3
   JMP WYBOR

UP1 TXA
    SEC
    SBC #8
    TAX
    BPL EDIT_LOP
 CLC
 ADC #32
 TAX
 BPL EDIT_LOP

DOWN1 TXA
      CLC
      ADC #8
 TAX
do2 CPX #32
    BCC GO_EDIT

 SEC
 SBC #32
 TAX
 BPL GO_EDIT

LEFT DEX
     BPL GO_EDIT

 LDX #31
 BNE GO_EDIT

RIGHT INX
      TXA
      JMP do2

RETURN LDY #0
       LDA (zNIC),Y
*CMP #''+64
       cmp #$42
       BNE _r4
       BEQ GO_EDIT

_r2      DEC fSING
GO_EDIT JMP EDIT_LOP

_r4 INC fSING

 LDY #0
*CMP #''+64
 cmp #$41
 BEQ _r6
 DEC fSING
 DEC fSING
 INY

_r6 LDA fSING
   CMP #1
   BEQ _r2

   LDA dSING,Y
   LDY #0
   STA (zNIC),Y

 JMP DOWN1

dSING DTA b($40),b($41)
fSING DTA B(0)


 LDA dSING,Y
MIG TXA
    ASL @
    TAY
    LDA aMIG,Y
 STA zNIC
    LDA aMIG+1,Y
 STA zNIC+1

 LDY #3
m1 LDA (zNIC),Y
   EOR #128
 STA (zNIC),Y
 DEY
 BPL m1
 RTS


seADR TXA
      AND #7

 CLC
 ADC <eBANK
 STA zNIC

 LDA #0
 ADC >eBANK
 STA zNIC+1

 TXA
 LSR @
 LSR @
 LSR @
 TAY
 LDA dPLUS,Y
 CLC
 ADC zNIC
 STA zNIC
 BCC *+4
 INC zNIC+1
 RTS
 
 
pm	equ $a000	;od adresu 'PM' bedzie nasz obszar na duchy i pociski

 
ClrPm lda #0
 tay
Clr sta pm+$300,y
 sta pm+$400,y
 sta pm+$500,y
 sta pm+$600,y
 sta pm+$700,y
 iny
 bne Clr
 rts


sprite	jsr ClrPm

	ldx #0
	lda #$ff
p00	sta pm+$400+112,x	;w tej tablicy znajduja sie dane opisujace ksztalt duszka
	inx
	cpx #48
	bne p00
	
	ldx #0
	lda #$ff
p00_	sta pm+$300+112,x	;w tej tablicy znajduja sie dane opisujace ksztalt duszka
	inx
	cpx #48
	bne p00_	

	ldx #0
	lda #%11111100
p01	sta pm+$500+152,x	;w tej tablicy znajduja sie dane opisujace ksztalt duszka
	inx
	cpx #32
	bne p01

	ldx #0
p02	lda #$ff
	sta pm+$600+128,x	;w tej tablicy znajduja sie dane opisujace ksztalt duszka
	lda #%11111100
	sta pm+$700+128,x
	inx
	cpx #40
	bne p02
	
	lda #$22
	sta 704		;cien rejestru koloru gracza0
	lda #$d4
	sta 705
	lda #$92
	sta 706
	sta 707
	lda #$2
	sta 710
	sta 712
	lda #10
	sta 709	

	lda #%00111110
	sta 559		;DMACTLS - dostep do pamieci dla duchow i pociskow wg odpowiednich bitow
	
	lda >pm
	sta $d407	;PMBASE - starszy adres obszaru z duchami
	lda #3
	sta $d01d	;PMCTL - czy wyswietlic duchy lub pociski, czy oba razem
	lda #%00001000
	sta 623		;GTICTLS - piorytet kolorw
	
	lda #3
	sta $d008	;SIZEP0 - szeroko
	sta $d00a
	sta $d00b
	sta $d009
	lda #%00000011
	sta $d00c

	lda #56
	sta $d000
	lda #56+32
	sta $d004
	lda #108
	sta $d001
	
	lda #148
	sta $d002
	lda #148+32
	sta $d003
	rts
	
aMIG DTA A(eMIG),A(eMIG+40),A(eMIG+120),A(eMIG+160)
dPLUS DTA B(0),B(40),B(80),B(120)

DL	DTA d'pppppppppppp',b($42),A(EKR+120),d'""""""""""',b($41),A(DL)

ekr	equ *
eBANK	equ ekr+$cb
eMIG 	equ ekr+$178
eDRIVE	equ ekr+$289

	ins 'ekran.obx',0,520
	ins 'ekran.obx',560,40

	org ekr+120+14	
	dta d'. . DuPLand Memory Setup'

	org $0100
;	dta b($ff)
dBANK16   DTA C'                  '

 	org $2e2
	dta a(start)
